t0060: sidestep surprising path mangling results on Windows
[git.git] / git-submodule.sh
blob82e95a923bd94f1da578f56e909da59594259170
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16 OPTIONS_SPEC=
17 SUBDIRECTORY_OK=Yes
18 . git-sh-setup
19 . git-sh-i18n
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
25 # Restrict ourselves to a vanilla subset of protocols; the URLs
26 # we get are under control of a remote repository, and we do not
27 # want them kicking off arbitrary git-remote-* programs.
29 # If the user has already specified a set of allowed protocols,
30 # we assume they know what they're doing and use that instead.
31 : ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32 export GIT_ALLOW_PROTOCOL
34 command=
35 branch=
36 force=
37 reference=
38 cached=
39 recursive=
40 init=
41 files=
42 remote=
43 nofetch=
44 update=
45 prefix=
46 custom_name=
47 depth=
49 # Resolve a path to be relative to another path. This is intended for
50 # converting submodule paths when git-submodule is run in a subdirectory
51 # and only handles paths where the directory separator is '/'.
53 # The output is the first argument as a path relative to the second argument,
54 # which defaults to $wt_prefix if it is omitted.
55 relative_path ()
57 local target curdir result
58 target=$1
59 curdir=${2-$wt_prefix}
60 curdir=${curdir%/}
61 result=
63 while test -n "$curdir"
65 case "$target" in
66 "$curdir/"*)
67 target=${target#"$curdir"/}
68 break
70 esac
72 result="${result}../"
73 if test "$curdir" = "${curdir%/*}"
74 then
75 curdir=
76 else
77 curdir="${curdir%/*}"
79 done
81 echo "$result$target"
84 die_if_unmatched ()
86 if test "$1" = "#unmatched"
87 then
88 exit 1
93 # Print a submodule configuration setting
95 # $1 = submodule name
96 # $2 = option name
97 # $3 = default value
99 # Checks in the usual git-config places first (for overrides),
100 # otherwise it falls back on .gitmodules. This allows you to
101 # distribute project-wide defaults in .gitmodules, while still
102 # customizing individual repositories if necessary. If the option is
103 # not in .gitmodules either, print a default value.
105 get_submodule_config () {
106 name="$1"
107 option="$2"
108 default="$3"
109 value=$(git config submodule."$name"."$option")
110 if test -z "$value"
111 then
112 value=$(git config -f .gitmodules submodule."$name"."$option")
114 printf '%s' "${value:-$default}"
117 isnumber()
119 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
123 # Add a new submodule to the working tree, .gitmodules and the index
125 # $@ = repo path
127 # optional branch is stored in global branch variable
129 cmd_add()
131 # parse $args after "submodule ... add".
132 reference_path=
133 while test $# -ne 0
135 case "$1" in
136 -b | --branch)
137 case "$2" in '') usage ;; esac
138 branch=$2
139 shift
141 -f | --force)
142 force=$1
144 -q|--quiet)
145 GIT_QUIET=1
147 --reference)
148 case "$2" in '') usage ;; esac
149 reference_path=$2
150 shift
152 --reference=*)
153 reference_path="${1#--reference=}"
155 --name)
156 case "$2" in '') usage ;; esac
157 custom_name=$2
158 shift
160 --depth)
161 case "$2" in '') usage ;; esac
162 depth="--depth=$2"
163 shift
165 --depth=*)
166 depth=$1
169 shift
170 break
173 usage
176 break
178 esac
179 shift
180 done
182 if test -n "$reference_path"
183 then
184 is_absolute_path "$reference_path" ||
185 reference_path="$wt_prefix$reference_path"
187 reference="--reference=$reference_path"
190 repo=$1
191 sm_path=$2
193 if test -z "$sm_path"; then
194 sm_path=$(printf '%s\n' "$repo" |
195 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
198 if test -z "$repo" || test -z "$sm_path"; then
199 usage
202 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
204 # assure repo is absolute or relative to parent
205 case "$repo" in
206 ./*|../*)
207 test -z "$wt_prefix" ||
208 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
210 # dereference source url relative to parent's url
211 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
213 *:*|/*)
214 # absolute url
215 realrepo=$repo
218 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
220 esac
222 # normalize path:
223 # multiple //; leading ./; /./; /../; trailing /
224 sm_path=$(printf '%s/\n' "$sm_path" |
225 sed -e '
226 s|//*|/|g
227 s|^\(\./\)*||
228 s|/\(\./\)*|/|g
229 :start
230 s|\([^/]*\)/\.\./||
231 tstart
232 s|/*$||
234 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
235 die "$(eval_gettext "'\$sm_path' already exists in the index")"
237 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
238 then
239 eval_gettextln "The following path is ignored by one of your .gitignore files:
240 \$sm_path
241 Use -f if you really want to add it." >&2
242 exit 1
245 if test -n "$custom_name"
246 then
247 sm_name="$custom_name"
248 else
249 sm_name="$sm_path"
252 # perhaps the path exists and is already a git repo, else clone it
253 if test -e "$sm_path"
254 then
255 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
256 then
257 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
258 else
259 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
262 else
263 if test -d ".git/modules/$sm_name"
264 then
265 if test -z "$force"
266 then
267 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
268 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
269 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
270 echo >&2 " $realrepo"
271 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
272 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
273 else
274 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
277 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" "$reference" "$depth" || exit
279 clear_local_git_env
280 cd "$sm_path" &&
281 # ash fails to wordsplit ${branch:+-b "$branch"...}
282 case "$branch" in
283 '') git checkout -f -q ;;
284 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
285 esac
286 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
288 git config submodule."$sm_name".url "$realrepo"
290 git add $force "$sm_path" ||
291 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
293 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
294 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
295 if test -n "$branch"
296 then
297 git config -f .gitmodules submodule."$sm_name".branch "$branch"
298 fi &&
299 git add --force .gitmodules ||
300 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
304 # Execute an arbitrary command sequence in each checked out
305 # submodule
307 # $@ = command to execute
309 cmd_foreach()
311 # parse $args after "submodule ... foreach".
312 while test $# -ne 0
314 case "$1" in
315 -q|--quiet)
316 GIT_QUIET=1
318 --recursive)
319 recursive=1
322 usage
325 break
327 esac
328 shift
329 done
331 toplevel=$(pwd)
333 # dup stdin so that it can be restored when running the external
334 # command in the subshell (and a recursive call to this function)
335 exec 3<&0
337 git submodule--helper list --prefix "$wt_prefix"|
338 while read mode sha1 stage sm_path
340 die_if_unmatched "$mode"
341 if test -e "$sm_path"/.git
342 then
343 displaypath=$(relative_path "$prefix$sm_path")
344 say "$(eval_gettext "Entering '\$displaypath'")"
345 name=$(git submodule--helper name "$sm_path")
347 prefix="$prefix$sm_path/"
348 clear_local_git_env
349 cd "$sm_path" &&
350 sm_path=$(relative_path "$sm_path") &&
351 # we make $path available to scripts ...
352 path=$sm_path &&
353 if test $# -eq 1
354 then
355 eval "$1"
356 else
357 "$@"
358 fi &&
359 if test -n "$recursive"
360 then
361 cmd_foreach "--recursive" "$@"
363 ) <&3 3<&- ||
364 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
366 done
370 # Register submodules in .git/config
372 # $@ = requested paths (default to all)
374 cmd_init()
376 # parse $args after "submodule ... init".
377 while test $# -ne 0
379 case "$1" in
380 -q|--quiet)
381 GIT_QUIET=1
384 shift
385 break
388 usage
391 break
393 esac
394 shift
395 done
397 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
401 # Unregister submodules from .git/config and remove their work tree
403 # $@ = requested paths (use '.' to deinit all submodules)
405 cmd_deinit()
407 # parse $args after "submodule ... deinit".
408 while test $# -ne 0
410 case "$1" in
411 -f|--force)
412 force=$1
414 -q|--quiet)
415 GIT_QUIET=1
418 shift
419 break
422 usage
425 break
427 esac
428 shift
429 done
431 if test $# = 0
432 then
433 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
436 git submodule--helper list --prefix "$wt_prefix" "$@" |
437 while read mode sha1 stage sm_path
439 die_if_unmatched "$mode"
440 name=$(git submodule--helper name "$sm_path") || exit
442 displaypath=$(relative_path "$sm_path")
444 # Remove the submodule work tree (unless the user already did it)
445 if test -d "$sm_path"
446 then
447 # Protect submodules containing a .git directory
448 if test -d "$sm_path/.git"
449 then
450 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
451 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
454 if test -z "$force"
455 then
456 git rm -qn "$sm_path" ||
457 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
459 rm -rf "$sm_path" &&
460 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
461 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
464 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
466 # Remove the .git/config entries (unless the user already did it)
467 if test -n "$(git config --get-regexp submodule."$name\.")"
468 then
469 # Remove the whole section so we have a clean state when
470 # the user later decides to init this submodule again
471 url=$(git config submodule."$name".url)
472 git config --remove-section submodule."$name" 2>/dev/null &&
473 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
475 done
478 is_tip_reachable () (
479 clear_local_git_env
480 cd "$1" &&
481 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
482 test -z "$rev"
485 fetch_in_submodule () (
486 clear_local_git_env
487 cd "$1" &&
488 case "$2" in
490 git fetch ;;
492 git fetch $(get_default_remote) "$2" ;;
493 esac
497 # Update each submodule path to correct revision, using clone and checkout as needed
499 # $@ = requested paths (default to all)
501 cmd_update()
503 # parse $args after "submodule ... update".
504 while test $# -ne 0
506 case "$1" in
507 -q|--quiet)
508 GIT_QUIET=1
510 -i|--init)
511 init=1
513 --remote)
514 remote=1
516 -N|--no-fetch)
517 nofetch=1
519 -f|--force)
520 force=$1
522 -r|--rebase)
523 update="rebase"
525 --reference)
526 case "$2" in '') usage ;; esac
527 reference="--reference=$2"
528 shift
530 --reference=*)
531 reference="$1"
533 -m|--merge)
534 update="merge"
536 --recursive)
537 recursive=1
539 --checkout)
540 update="checkout"
542 --depth)
543 case "$2" in '') usage ;; esac
544 depth="--depth=$2"
545 shift
547 --depth=*)
548 depth=$1
550 -j|--jobs)
551 case "$2" in '') usage ;; esac
552 jobs="--jobs=$2"
553 shift
555 --jobs=*)
556 jobs=$1
559 shift
560 break
563 usage
566 break
568 esac
569 shift
570 done
572 if test -n "$init"
573 then
574 cmd_init "--" "$@" || return
578 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
579 ${wt_prefix:+--prefix "$wt_prefix"} \
580 ${prefix:+--recursive-prefix "$prefix"} \
581 ${update:+--update "$update"} \
582 ${reference:+--reference "$reference"} \
583 ${depth:+--depth "$depth"} \
584 ${jobs:+$jobs} \
585 "$@" || echo "#unmatched"
586 } | {
587 err=
588 while read mode sha1 stage just_cloned sm_path
590 die_if_unmatched "$mode"
592 name=$(git submodule--helper name "$sm_path") || exit
593 url=$(git config submodule."$name".url)
594 branch=$(get_submodule_config "$name" branch master)
595 if ! test -z "$update"
596 then
597 update_module=$update
598 else
599 update_module=$(git config submodule."$name".update)
600 if test -z "$update_module"
601 then
602 update_module="checkout"
606 displaypath=$(relative_path "$prefix$sm_path")
608 if test $just_cloned -eq 1
609 then
610 subsha1=
611 update_module=checkout
612 else
613 subsha1=$(clear_local_git_env; cd "$sm_path" &&
614 git rev-parse --verify HEAD) ||
615 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
618 if test -n "$remote"
619 then
620 if test -z "$nofetch"
621 then
622 # Fetch remote before determining tracking $sha1
623 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
624 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
626 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
627 sha1=$(clear_local_git_env; cd "$sm_path" &&
628 git rev-parse --verify "${remote_name}/${branch}") ||
629 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
632 if test "$subsha1" != "$sha1" || test -n "$force"
633 then
634 subforce=$force
635 # If we don't already have a -f flag and the submodule has never been checked out
636 if test -z "$subsha1" && test -z "$force"
637 then
638 subforce="-f"
641 if test -z "$nofetch"
642 then
643 # Run fetch only if $sha1 isn't present or it
644 # is not reachable from a ref.
645 is_tip_reachable "$sm_path" "$sha1" ||
646 fetch_in_submodule "$sm_path" ||
647 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
649 # Now we tried the usual fetch, but $sha1 may
650 # not be reachable from any of the refs
651 is_tip_reachable "$sm_path" "$sha1" ||
652 fetch_in_submodule "$sm_path" "$sha1" ||
653 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
656 must_die_on_failure=
657 case "$update_module" in
658 checkout)
659 command="git checkout $subforce -q"
660 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
661 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
663 rebase)
664 command="git rebase"
665 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
666 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
667 must_die_on_failure=yes
669 merge)
670 command="git merge"
671 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
672 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
673 must_die_on_failure=yes
676 command="${update_module#!}"
677 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
678 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
679 must_die_on_failure=yes
682 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
683 esac
685 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
686 then
687 say "$say_msg"
688 elif test -n "$must_die_on_failure"
689 then
690 die_with_status 2 "$die_msg"
691 else
692 err="${err};$die_msg"
693 continue
697 if test -n "$recursive"
698 then
700 prefix=$(relative_path "$prefix$sm_path/")
701 wt_prefix=
702 clear_local_git_env
703 cd "$sm_path" &&
704 eval cmd_update
706 res=$?
707 if test $res -gt 0
708 then
709 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
710 if test $res -eq 1
711 then
712 err="${err};$die_msg"
713 continue
714 else
715 die_with_status $res "$die_msg"
719 done
721 if test -n "$err"
722 then
723 OIFS=$IFS
724 IFS=';'
725 for e in $err
727 if test -n "$e"
728 then
729 echo >&2 "$e"
731 done
732 IFS=$OIFS
733 exit 1
738 set_name_rev () {
739 revname=$( (
740 clear_local_git_env
741 cd "$1" && {
742 git describe "$2" 2>/dev/null ||
743 git describe --tags "$2" 2>/dev/null ||
744 git describe --contains "$2" 2>/dev/null ||
745 git describe --all --always "$2"
748 test -z "$revname" || revname=" ($revname)"
751 # Show commit summary for submodules in index or working tree
753 # If '--cached' is given, show summary between index and given commit,
754 # or between working tree and given commit
756 # $@ = [commit (default 'HEAD'),] requested paths (default all)
758 cmd_summary() {
759 summary_limit=-1
760 for_status=
761 diff_cmd=diff-index
763 # parse $args after "submodule ... summary".
764 while test $# -ne 0
766 case "$1" in
767 --cached)
768 cached="$1"
770 --files)
771 files="$1"
773 --for-status)
774 for_status="$1"
776 -n|--summary-limit)
777 summary_limit="$2"
778 isnumber "$summary_limit" || usage
779 shift
781 --summary-limit=*)
782 summary_limit="${1#--summary-limit=}"
783 isnumber "$summary_limit" || usage
786 shift
787 break
790 usage
793 break
795 esac
796 shift
797 done
799 test $summary_limit = 0 && return
801 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
802 then
803 head=$rev
804 test $# = 0 || shift
805 elif test -z "$1" || test "$1" = "HEAD"
806 then
807 # before the first commit: compare with an empty tree
808 head=$(git hash-object -w -t tree --stdin </dev/null)
809 test -z "$1" || shift
810 else
811 head="HEAD"
814 if [ -n "$files" ]
815 then
816 test -n "$cached" &&
817 die "$(gettext "The --cached option cannot be used with the --files option")"
818 diff_cmd=diff-files
819 head=
822 cd_to_toplevel
823 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
824 # Get modified modules cared by user
825 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
826 sane_egrep '^:([0-7]* )?160000' |
827 while read mod_src mod_dst sha1_src sha1_dst status sm_path
829 # Always show modules deleted or type-changed (blob<->module)
830 if test "$status" = D || test "$status" = T
831 then
832 printf '%s\n' "$sm_path"
833 continue
835 # Respect the ignore setting for --for-status.
836 if test -n "$for_status"
837 then
838 name=$(git submodule--helper name "$sm_path")
839 ignore_config=$(get_submodule_config "$name" ignore none)
840 test $status != A && test $ignore_config = all && continue
842 # Also show added or modified modules which are checked out
843 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
844 printf '%s\n' "$sm_path"
845 done
848 test -z "$modules" && return
850 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
851 sane_egrep '^:([0-7]* )?160000' |
852 cut -c2- |
853 while read mod_src mod_dst sha1_src sha1_dst status name
855 if test -z "$cached" &&
856 test $sha1_dst = 0000000000000000000000000000000000000000
857 then
858 case "$mod_dst" in
859 160000)
860 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
862 100644 | 100755 | 120000)
863 sha1_dst=$(git hash-object $name)
865 000000)
866 ;; # removed
868 # unexpected type
869 eval_gettextln "unexpected mode \$mod_dst" >&2
870 continue ;;
871 esac
873 missing_src=
874 missing_dst=
876 test $mod_src = 160000 &&
877 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
878 missing_src=t
880 test $mod_dst = 160000 &&
881 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
882 missing_dst=t
884 display_name=$(relative_path "$name")
886 total_commits=
887 case "$missing_src,$missing_dst" in
889 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
892 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
894 t,t)
895 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
898 errmsg=
899 total_commits=$(
900 if test $mod_src = 160000 && test $mod_dst = 160000
901 then
902 range="$sha1_src...$sha1_dst"
903 elif test $mod_src = 160000
904 then
905 range=$sha1_src
906 else
907 range=$sha1_dst
909 GIT_DIR="$name/.git" \
910 git rev-list --first-parent $range -- | wc -l
912 total_commits=" ($(($total_commits + 0)))"
914 esac
916 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
917 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
918 if test $status = T
919 then
920 blob="$(gettext "blob")"
921 submodule="$(gettext "submodule")"
922 if test $mod_dst = 160000
923 then
924 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
925 else
926 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
928 else
929 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
931 if test -n "$errmsg"
932 then
933 # Don't give error msg for modification whose dst is not submodule
934 # i.e. deleted or changed to blob
935 test $mod_dst = 160000 && echo "$errmsg"
936 else
937 if test $mod_src = 160000 && test $mod_dst = 160000
938 then
939 limit=
940 test $summary_limit -gt 0 && limit="-$summary_limit"
941 GIT_DIR="$name/.git" \
942 git log $limit --pretty='format: %m %s' \
943 --first-parent $sha1_src...$sha1_dst
944 elif test $mod_dst = 160000
945 then
946 GIT_DIR="$name/.git" \
947 git log --pretty='format: > %s' -1 $sha1_dst
948 else
949 GIT_DIR="$name/.git" \
950 git log --pretty='format: < %s' -1 $sha1_src
952 echo
954 echo
955 done
958 # List all submodules, prefixed with:
959 # - submodule not initialized
960 # + different revision checked out
962 # If --cached was specified the revision in the index will be printed
963 # instead of the currently checked out revision.
965 # $@ = requested paths (default to all)
967 cmd_status()
969 # parse $args after "submodule ... status".
970 while test $# -ne 0
972 case "$1" in
973 -q|--quiet)
974 GIT_QUIET=1
976 --cached)
977 cached=1
979 --recursive)
980 recursive=1
983 shift
984 break
987 usage
990 break
992 esac
993 shift
994 done
996 git submodule--helper list --prefix "$wt_prefix" "$@" |
997 while read mode sha1 stage sm_path
999 die_if_unmatched "$mode"
1000 name=$(git submodule--helper name "$sm_path") || exit
1001 url=$(git config submodule."$name".url)
1002 displaypath=$(relative_path "$prefix$sm_path")
1003 if test "$stage" = U
1004 then
1005 say "U$sha1 $displaypath"
1006 continue
1008 if test -z "$url" ||
1010 ! test -d "$sm_path"/.git &&
1011 ! test -f "$sm_path"/.git
1013 then
1014 say "-$sha1 $displaypath"
1015 continue;
1017 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1018 then
1019 set_name_rev "$sm_path" "$sha1"
1020 say " $sha1 $displaypath$revname"
1021 else
1022 if test -z "$cached"
1023 then
1024 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1026 set_name_rev "$sm_path" "$sha1"
1027 say "+$sha1 $displaypath$revname"
1030 if test -n "$recursive"
1031 then
1033 prefix="$displaypath/"
1034 clear_local_git_env
1035 wt_prefix=
1036 cd "$sm_path" &&
1037 eval cmd_status
1038 ) ||
1039 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1041 done
1044 # Sync remote urls for submodules
1045 # This makes the value for remote.$remote.url match the value
1046 # specified in .gitmodules.
1048 cmd_sync()
1050 while test $# -ne 0
1052 case "$1" in
1053 -q|--quiet)
1054 GIT_QUIET=1
1055 shift
1057 --recursive)
1058 recursive=1
1059 shift
1062 shift
1063 break
1066 usage
1069 break
1071 esac
1072 done
1073 cd_to_toplevel
1074 git submodule--helper list --prefix "$wt_prefix" "$@" |
1075 while read mode sha1 stage sm_path
1077 die_if_unmatched "$mode"
1078 name=$(git submodule--helper name "$sm_path")
1079 url=$(git config -f .gitmodules --get submodule."$name".url)
1081 # Possibly a url relative to parent
1082 case "$url" in
1083 ./*|../*)
1084 # rewrite foo/bar as ../.. to find path from
1085 # submodule work tree to superproject work tree
1086 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1087 # guarantee a trailing /
1088 up_path=${up_path%/}/ &&
1089 # path from submodule work tree to submodule origin repo
1090 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1091 # path from superproject work tree to submodule origin repo
1092 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1095 sub_origin_url="$url"
1096 super_config_url="$url"
1098 esac
1100 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1101 then
1102 displaypath=$(relative_path "$prefix$sm_path")
1103 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1104 git config submodule."$name".url "$super_config_url"
1106 if test -e "$sm_path"/.git
1107 then
1109 clear_local_git_env
1110 cd "$sm_path"
1111 remote=$(get_default_remote)
1112 git config remote."$remote".url "$sub_origin_url"
1114 if test -n "$recursive"
1115 then
1116 prefix="$prefix$sm_path/"
1117 eval cmd_sync
1122 done
1125 # This loop parses the command line arguments to find the
1126 # subcommand name to dispatch. Parsing of the subcommand specific
1127 # options are primarily done by the subcommand implementations.
1128 # Subcommand specific options such as --branch and --cached are
1129 # parsed here as well, for backward compatibility.
1131 while test $# != 0 && test -z "$command"
1133 case "$1" in
1134 add | foreach | init | deinit | update | status | summary | sync)
1135 command=$1
1137 -q|--quiet)
1138 GIT_QUIET=1
1140 -b|--branch)
1141 case "$2" in
1143 usage
1145 esac
1146 branch="$2"; shift
1148 --cached)
1149 cached="$1"
1152 break
1155 usage
1158 break
1160 esac
1161 shift
1162 done
1164 # No command word defaults to "status"
1165 if test -z "$command"
1166 then
1167 if test $# = 0
1168 then
1169 command=status
1170 else
1171 usage
1175 # "-b branch" is accepted only by "add"
1176 if test -n "$branch" && test "$command" != add
1177 then
1178 usage
1181 # "--cached" is accepted only by "status" and "summary"
1182 if test -n "$cached" && test "$command" != status && test "$command" != summary
1183 then
1184 usage
1187 "cmd_$command" "$@"